
var options = {
	host: '',
	applicationId: '',
	redirectUri: '',

	dialplan: 'alarmclock',
}


var wtapi = null;
var hotelView = null;
var settingsModal = null;
var updateTimer = null;

function oauth2Callback(params) {
	wtapi.handleCallbackData(params);
}

function isHasChanges(options) {
	for (const [optionName, optionValue] of Object.entries(options)) {
		if (localStorage.getItem(optionName) !== optionValue) {
			return true;
		}
	}
	return false;
}

$(document).ready(function() {
	$.ajaxSetup({
		crossDomain: true,
		xhrFields: {
			withCredentials: false
		},
	});

    settingsModal = $("#settings-modal");

    $('#settings-btn').on('click', function(){
    	settingsModal.modal('show');
    });

    $('#hotel-view').on('click', '.actions .alarmclocks', onClickAlarmClocks);
    $('#hotel-view').on('click', '.actions .checkin', onClickCheckIn);
    $('#hotel-view').on('click', '.actions .checkout', onClickCheckOut);
    $('#hotel-view').on('click', '.actions .cleaning', onClickCleaning);
    $('#hotel-view').on('click', '.actions .cleaned', onClickCleaned);
    $('#hotel-view').on('click', '.actions .call-history', onClickCallHistory);

    $('#check-in-save-button').on('click', onClickSaveCheckIn);

    $('#alarm-clocks-add-button').on('click', onClickAddAlarmClock);
    $('#alarm-clocks-modal').on('click', '.actions .edit', onClickEditAlarmClock);
    $('#alarm-clocks-modal').on('click', '.actions .del', onClickDelAlarmClock);
    $('#alarm-clock-edit-save-button').on('click', onClickSaveAlarmClock);

    $('#settings-modal-save-button').on('click', onClickSettingsSave);

    $('#call-history-update-button').on('click', onClickUpdateCallHistory);
    $('#call-history-print-button').on('click', onClickPrintCallHistory);

    $('#call-history-from-date').datetimepicker({
        dateFormat: "dd/mm/yy",
        timeFormat: 'HH:mm',
        changeMonth: true,
        changeYear: true,
        showButtonPanel: false
    });

    $('#call-history-to-date').datetimepicker({
        dateFormat: "dd/mm/yy",
        timeFormat: 'HH:mm',
        changeMonth: true,
        changeYear: true,
        showButtonPanel: false
    });

    initialise();

});

$.template("usersTemplate", "" +
		"<table cellpadding='0' cellspacing='0'>" +
		"<thead>" +
		"<tr>" +
			"<th></th>" +
			"<th></th>" +
			"<th></th>" +
		"</tr>" +
		"</thead>" +
		"<tbody>" +
			"{{each(group, users) roster}}" +
			"<tr class='group-header'>" +
				"<td>${group}</td>" +
			"</tr>" +
			"{{each(id, user) users}}" +
			"<tr class='user-item' id='user_${user.getExtension()}' extension='${user.getExtension()}'>" +
				"<td class='name tooltip-applied'><a href='#'><i class='user-status'></i><span>${user.getName()} <i></i></span><i class='status ringing' style='display: none;'></i><i class='status talking' style='display: none;'></i><i class='fa fa-map-marker location' style='display: none;'></i></a></td>" +
				"<td class='extension'>${user.getExtension()}</td>" +
				"<td class='actions'>" +
					"<button class='action-btn fa fa-sign-in btn btn-default checkin' data-toggle='tooltip' data-placement='top' title='Press to check in'></button>" +
					"<button class='action-btn fa fa-user btn btn-default checkout' data-toggle='tooltip' data-placement='top' title='Press to check out'></button>" +
					"<button class='action-btn fa fa-cleaning btn btn-default cleaning' data-toggle='tooltip' data-placement='top' title='Press to make up room'></button>" +
					"<button class='action-btn fa fa-check btn btn-default cleaned' data-toggle='tooltip' data-placement='top' title='Press to cleaned room'></button>" +
					"<button class='action-btn fa fa-clock-o btn btn-default alarmclocks' data-toggle='tooltip' data-placement='top' title='Alarm clocks'><span>0</span></button>" +
					"<button class='action-btn fa fa-history btn btn-default call-history' data-toggle='tooltip' data-placement='top' title='Call history'></button>" +
				"</td>" +
			"</tr>" +
			"{{/each}}" +
			"{{/each}}" +
		"</tbody>" +
		"</table>");

$.template("alarmClocksTemplate", "" +
		"<table width='100%' cellpadding='0' cellspacing='0' rel='${extension}'>" +
		"<thead>" +
		"<tr>" +
			"<th class='hide'>ID</th>" +
			"<th>Number</th>" +
			"<th class='hide'>Dialplan</th>" +
			"<th>Time</th>" +
			"<th></th>" +
		"</tr>" +
		"</thead>" +
		"<tbody>" +
			"{{each(id, alarmClock) alarmClocks}}" +
			"<tr class='alarm-clock-item' id='alarm_clock_${alarmClock.id}' rel='${alarmClock.id}'>" +
				"<td class='id hide'>${alarmClock.id}</td>" +
				"<td class='number'>${alarmClock.number}</td>" +
				"<td class='dialplan hide'>${alarmClock.dialplan}</td>" +
				"<td class='postpone'>${alarmClock.postpone}</td>" +
				"<td class='actions'>" +
					"<button class='action-btn fa fa-pencil btn btn-default edit' data-toggle='tooltip' data-placement='top' title='Edit'></button>" +
					"<button class='action-btn fa fa-times btn btn-default del' data-toggle='tooltip' data-placement='top' title='Remove'></button>" +
				"</td>" +
			"</tr>" +
			"{{/each}}" +
		"</tbody>" +
		"</table>");

$.template("callHistoryTemplate", "" +
		"<table width='100%' cellpadding='0' cellspacing='0'>" +
		"<thead>" +
		"<tr>" +
			"<th class='icon'></th>" +
			"<th class='name'>Name</th>" +
			"<th class='number'>Number</th>" +
			"<th class='date'>Date</th>" +
			"<th class='dateFull'>Date</th>" +
			"<th class='duration'>Duration</th>" +
			"<th class='cost'>Cost</th>" +
		"</tr>" +
		"</thead>" +
		"<tbody>" +
			"{{each(id, call) callHistory}}" +
			"<tr class='call-history-item'>" +
				"<td class='icon'><span class='fa-stack fa-lg'>" +
					"{{if call.isIn == false}}" +
					"<i class='fa fa-phone fa-stack-2x'></i>" +
					"<i class='fa fa-long-arrow-up fa-stack-1x fa-thumb-tack fa-rotate-45'></i>" +
					"{{/if}}" +
				"</span></td>" +
				"<td class='name'>${call.name}</td>" +
				"<td class='number'>${call.number}</td>" +
				"<td class='date'><span class='tooltip-applied' data-toggle='tooltip' data-placement='top' title='${call.dateFull}'>${call.date}</td>" +
				"<td class='dateFull'><span class='tooltip-applied' data-toggle='tooltip' data-placement='top' title='${call.date}'>${call.dateFull}</td>" +
				"<td class='duration'>${call.duration}</td>" +
				"<td class='cost'>${call.cost}</td>" +
			"</tr>" +
			"{{/each}}" +
			"<tr class='call-history-item'>" +
				"<td></td>" +
				"<td></td>" +
				"<td></td>" +
				"<td></td>" +
				"<td align='right'><b>Total:</b></td>" +
				"<td align='center'><b>${totalCost}</b></td>" +
			"</tr>" +
		"</tbody>" +
		"</table>" +
		"${callHistory.length} of ${total}");

$.template("printCalls", "" +
		"<html>" +
		"<head>" +
			"<title>Print</title>" +
			"<style>" +
				"th {text-align: left;}" +
				".head th{padding-right: 10px;}" +
				".head {margin-bottom: 15px;}" +
				".date{display: none;}" +
				"td.dateFull, td.duration, td.cost, th.dateFull, th.duration, th.cost{text-align: center;}" +
			"</style>" +
		"</head>" +
		"<body>" +
			"<table class='head' cellpadding='0' cellspacing='0'>" +
				"<tr><th>User</th><td> ${user.getName()}</td></tr>" +
				"<tr><th>Period</th><td> ${period.from} - ${period.to}</td></tr>" +
				"<tr><th>Date</th><td> ${date}</td></tr>" +
			"</table>" +
			"{{html callsHistory}}"+
		"</body>" +
		"</html>");


function initialise(){
	options = {
		pbxUrl: localStorage.getItem("host"),
		applicationId: localStorage.getItem("applicationId"),
		redirectUri: calcRedirectUri(),
		dialplan: localStorage.getItem("hotel_dialplan")
	}

	$('#settings-modal-host').val(options.pbxUrl);
	$('#settings-modal-application').val(options.applicationId);
	$('#settings-modal-redirect-uri').val(options.redirectUri);
	$('#settings-modal-dialplan').val(options.dialplan);

	if(wtapi){
		wtapi = null;
	}

	if(!options.pbxUrl || !options.applicationId || !options.redirectUri) {
		return false;
	}

	wtapi = new WTAPI();
	wtapi.setOptions(options);

	wtapi.on("connected", onConnected);
	wtapi.on("disconnected", onDisconnected);
	wtapi.presence.on("presence_changed", onPresenceChanged)

	wtapi.on("restoreCredentials", onRestoreCredentials);
	wtapi.restoreSavedCredentials();
}

function calcRedirectUri() {
	let redirectUri = '';
	if (typeof(localStorage.redirectUri) === "string" && localStorage.redirectUri !== '') {
		redirectUri = localStorage.redirectUri;
	} else {
		let loc = window.location;
		let pathname = loc.pathname
			.replace('index.html', '')
			.replace('hotelManager/', '');
		redirectUri = loc.origin + pathname + 'oauth2redirect.html';
	}

	return redirectUri;
}

function onRestoreCredentials(data) {
	console.log('Restored credentials', data);
	initHotel(data === null, data);
}

function initHotel(needConnect = true) {
	$.ajaxSetup({
		crossDomain: true,
		xhrFields: {
			withCredentials: false
		},
	});

	if (needConnect) {
		wtapi.connect();
	}
}

function showError(title, error){
	console.log(title, error);
	$("#error-view-modal").modal('hide');
	$('#error-view-modal .modal-title').html(title);
	$('#error-view-modal .modal-body').html(error);
	$("#error-view-modal").modal('show');
}

var blockingCalls = [];
function getBlockingCalls(){
	$.ajax({
		url: options.pbxUrl+'/api/v1/Dialplan/db/allowcalls/',
		type: 'GET',
		success:function(data, textStatus, jqXHR){
			if(data && data['type'] && data['type'] == 'result' && data['result']){
				if(data.result['total'] > 0){
					blockingCalls = data.result.records;
					updateButtons();
				}
			}
		},
		error: function(jqXHR, textStatus, errorThrown){
			if(jqXHR.responseText && jqXHR.responseText!=''){
				var response = $.parseJSON(jqXHR.responseText);
				if(response && response['type'] && response['type'] == 'error' && response['reason']){
					showError('Error get blocking calls', response['reason'])
					updateButtons();
				}
			}else{
				showError('Error get blocking calls', errorThrown)
			}
		}
	});
}

function setStatus(extension, status, message, until){
	if(until){
		until = formatDate(until);
	}
	$.ajax({
		url: options.pbxUrl+'/api/v1/User/'+extension+'/Presence/',
		type: 'POST',
		data:{
			_METHOD: 'PUT',
			status: status,
			message: message,
			until: until
		},
		success:function(response, textStatus, jqXHR){
			if(response && response['type'] && response['type'] == 'result'){

			}else{
				console.log(response);
			}
		},
		error: function(jqXHR, textStatus, errorThrown){
			console.log(jqXHR.responseText)
			if(jqXHR.responseText && jqXHR.responseText!=''){
				var response = $.parseJSON(jqXHR.responseText);
				if(response && response['type'] && response['type'] == 'error' && response['reason']){
					showError('Error set status ', response['reason']);
				}
			}else{
				showError('Error set status ', errorThrown);
			}
		}
	});
}

function loadHistory(extension, fromDate, toDate){
	$("#call-history-modal .modal-content").mask('Loading ...');
	$.ajax({
		url: options.pbxUrl+'/api/v1/User/'+extension+'/CallHistory/',
		type: 'GET',
		data:{
			start: 0,
			count: 200,
			fields: 'billsec,cost,start,to_name,to_number,from_name,from_number,organization',
			filter: {
				start:{
					from: fromDate,
					to: toDate
				}
			}
		},
		success:function(response, textStatus, jqXHR){
			if(response && response['type'] && response['type'] == 'result'){
				var result = response['result'];
				var calls = [];
				var totalCost = 0;
				for(var i=0; i<result.records.length; i++){
					var call = result.records[i];

					// Direction
					var isIn = call['from_number'] == extension ? false: true;

					// Number and Name
					var name = '';
					var number = '';
		            if(isIn){
		            	name =  call['from_name'];
		            	number = call['from_number'];
		            }else{
		            	name =  call['to_name'];
		            	number = call['to_number'];
		            }
		            if(call['organization'] != ''){
		            	name += ' (' + call['organization'] + ')';
		            }

		            // Date
		            var date = call.start.replace(/-/g, "/");

		            // Duration
		            var duration = Number(call.billsec);
		    		var h = Math.floor(duration / 3600);
		    		var m = Math.floor(duration % 3600 / 60);
		    		var s = Math.floor(duration % 3600 % 60);
		    		duration = ((h > 0 ? h + ":" : "") + (m > 0 ? (h > 0 && m < 10 ? "0" : "") + m + ":" : "0:") + (s < 10 ? "0" : "") + s);

		    		var cost = (call.cost == '')? 0 : Number(call.cost);
		    		totalCost+=cost;
					calls.push({
						number: number,
						name: name,
						dateFull: new Date(date).format('dd/mm/yyyy HH:MM:ss'),
						date: new Date(date).toShortDate(),
						duration: duration,
						cost: cost,
						isIn: isIn
					});

				}

				$('#call-history-modal .modal-body .call-history-wrapper').html($.tmpl("callHistoryTemplate", {
						'callHistory': calls,
						'total': result['total'],
						'totalCost': totalCost.toFixed(2)
					}
				));

				$('#call-history-modal .modal-body .call-history-wrapper [data-toggle="tooltip"]').tooltip();
			}else{
				console.log(response);
			}
		},
		error: function(jqXHR, textStatus, errorThrown){
			if(jqXHR.responseText && jqXHR.responseText!=''){
				var response = $.parseJSON(jqXHR.responseText);
				if(response && response['type'] && response['type'] == 'error' && response['reason']){
					showError('Error get call history', response['reason']);
				}
			}else{
				showError('Error get call history', errorThrown);
			}
		},
		complete: function(){
			$("#call-history-modal .modal-content").unmask();
		}
	});
}

function formatDate(date) {
    return date.getDate() + "/" + (date.getMonth() + 1) + "/" + date.getFullYear() + " " + date.getHours() + ":" + date.getMinutes();
}

var alarmClocks = {};
function getAlarmClocks(){
	$.ajax({
		url: options.pbxUrl+'/api/v1/originate/AlarmClocks/',
		type: 'GET',
		success:function(data, textStatus, jqXHR){
			if(data && data['type'] && data['type'] == 'result' && data['result']){
				if(data.result['total'] > 0){
					alarmClocks = {};
					for(var i=0; i<data.result.records.length; i++){
						var alarmClock = data.result.records[i];
						if(!alarmClocks[alarmClock.number]){
							alarmClocks[alarmClock.number] = [];
						}
						alarmClocks[alarmClock.number].push(alarmClock);
					}
					updateButtons();
				}
			}
		},
		error: function(jqXHR, textStatus, errorThrown){
			if(jqXHR.responseText && jqXHR.responseText!=''){
				var response = $.parseJSON(jqXHR.responseText);
				if(response && response['type'] && response['type'] == 'error' && response['reason']){
					showError('Error get alarm clocks', response['reason']);
				}
			}else{
				showError('Error get alarm clocks', errorThrown);
			}
		}
	});
}

function updateButtons(){

	if(blockingCalls){
		$('#hotel-view .actions .checkin').show();
		for(var i=0; i<blockingCalls.length; i++){

			var extension = blockingCalls[i].key.replace('/allowcalls/', '');
			if(blockingCalls[i].value == '1'){
				$('#user_'+extension+' .actions .checkin').hide();
				$('#user_'+extension+' .actions .checkout').show();
			}else{
				$('#user_'+extension+' .actions .checkin').show();
				$('#user_'+extension+' .actions .checkout').hide();
			}
		}
	}

	$('#hotel-view .actions .alarmclocks').show();
	$('#hotel-view .actions .call-history').show();
	if(alarmClocks){
		$.each(alarmClocks, function(key, value){
			$('#user_'+key+' .actions .alarmclocks').attr('title', 'Alarm Clocks');
			$('#user_'+key+' .actions .alarmclocks span').text(value.length);
		});
	}
}

function updateDialplanDbKey(extension, value, callback){
	if(!callback){
		callback = function(){};
	}
	$.ajax({
		url: options.pbxUrl+'/api/v1/Dialplan/DB/allowcalls/'+extension+'/',
		type: 'POST',
		data:{
			value: value
		},
		success:function(response, textStatus, jqXHR){
			if(response && response['type'] && response['type'] == 'result'){
				var finded = false;
				for(var i=0; i < blockingCalls.length;i++){
					if(blockingCalls[i].key == ('/allowcalls/'+extension)){
						blockingCalls[i].value = value;
						finded = true;
						break;
					}
				}
				if(!finded){
					blockingCalls.push({
						key: '/allowcalls/'+extension,
						value: value
					})
				}
				callback();
				updateButtons();
			}else{
				console.log(response);
			}
		},
		error: function(jqXHR, textStatus, errorThrown){
			if(jqXHR.responseText && jqXHR.responseText!=''){
				var response = $.parseJSON(jqXHR.responseText);
				if(response && response['type'] && response['type'] == 'error' && response['reason']){
					showError('Error update dialplan database value', response['reason']);
				}
			}else{
				showError('Error update dialplan database value', errorThrown);
			}
		}
	});
}

function updateUserName(extension, name){

	$.ajax({
		url: options.pbxUrl+'/api/v1/User/'+extension+'/',
		type: 'PUT',
		data:{
			data:{
				name: name
			}
		},
		success:function(response, textStatus, jqXHR){
			if(response && response['type'] && response['type'] == 'result'){
				$('.users-list .user-item[extension="'+extension+'"] td.name a span').text(name);
			}else{
				console.log(response);
			}
		},
		error: function(jqXHR, textStatus, errorThrown){
			if(jqXHR.responseText && jqXHR.responseText!=''){
				var response = $.parseJSON(jqXHR.responseText);
				if(response && response['type'] && response['type'] == 'error' && response['reason']){
					showError('Error update colleague: ', response['reason']);
				}
			}else{
				showError('Error update colleague: ', errorThrown);
			}
		}
	});
}

function onClickSettingsSave(){
	let host = $('#settings-modal-host').val();
	let re = new RegExp("^(http|https)://", 'i');
	if (host && !re.test(host)) {
		host = 'https://' + host;
	}

	const applicationId = $('#settings-modal-application').val();
	const redirectUri = $('#settings-modal-redirect-uri').val();
	const hotel_dialplan = $('#settings-modal-dialplan').val();

	const hasChanges = isHasChanges({
		host,
		applicationId,
		redirectUri,
		hotel_dialplan
	});

	if (hasChanges === true) {
		localStorage.setItem("host", host);
		localStorage.setItem("applicationId", applicationId);
		localStorage.setItem("redirectUri", redirectUri);
		localStorage.setItem("hotel_dialplan", hotel_dialplan);

		if (wtapi) {
			wtapi.disconnect();
		}

		initialise();
	}
	settingsModal.modal('hide');
}

function onClickCheckIn(event){
	var extension = $.trim($(event.target).closest('tr.user-item').attr('extension'));
	var name = $.trim($(event.target).closest('tr.user-item').find('.name span').text());
	if(name){
		$('#check-in-modal .modal-body .check-in-wrapper input[name="extension"]').val(extension);
		$('#check-in-modal .modal-body .check-in-wrapper input[name="current-name"]').val(name);
		$('#check-in-modal .modal-body .check-in-wrapper input[name="name"]').val('');
		$('#check-in-modal .modal-body .check-in-wrapper [data-toggle="tooltip"]').tooltip();
	}
	$("#check-in-modal").modal('show');
}

function onClickSaveCheckIn(event){
	var extension = $.trim($('#check-in-modal .modal-body .check-in-wrapper input[name="extension"]').val());
	var currentName = $.trim($('#check-in-modal .modal-body .check-in-wrapper input[name="current-name"]').val());
	var name = $.trim($('#check-in-modal .modal-body .check-in-wrapper input[name="name"]').val());

	if($.trim(name) != ''){
		name = currentName+'-'+name;
	}else{
		name = currentName;
	}

	localStorage.setItem('checkin_'+extension, Math.floor(new Date().getTime()));
	localStorage.removeItem('checkout_'+extension);

	updateDialplanDbKey(extension, '1', function(){
		if(name != currentName){
			updateUserName(extension, name);
		}
		$('#check-in-modal').modal('hide');
	});
}

function onClickCheckOut(event){
	var extension = $(event.target).closest('tr.user-item').attr('extension');
	var name = $.trim($(event.target).closest('tr.user-item').find('.name span').text());
	var splitedName = name.split('-');
	updateDialplanDbKey(extension, '0', function(){
		if(name != splitedName[0]){
			updateUserName(extension, $.trim(splitedName[0]));
		}
	});
	localStorage.setItem('checkout_'+extension, Math.floor(new Date().getTime()));
}

function onClickCleaning(event){
	var extension = $(event.target).closest('tr.user-item').attr('extension');
	var user = wtapi.roster.getUserByExtension(extension);
	var presence = wtapi.presence.get(user);
	setStatus(extension, 'mur', presence.getStatusMessage(), presence.getStatusUntil());
}

function onClickCleaned(event){
	var extension = $(event.target).closest('tr.user-item').attr('extension');
	var user = wtapi.roster.getUserByExtension(extension);
	var presence = wtapi.presence.get(user);
	setStatus(extension, 'available', presence.getStatusMessage(), presence.getStatusUntil());
}



function onClickCallHistory(event){

	var extension = $(event.target).closest('tr.user-item').attr('extension');
	$('#call-history-modal').attr('extension', extension);

	var checkInTime = Number(localStorage.getItem('checkin_'+extension));
	if(!checkInTime){
		var yesterdayDate = new Date();
		yesterdayDate.setDate(yesterdayDate.getDate()-1);
		checkInTime = yesterdayDate.getTime();
	}
	var checkInDate = new Date(checkInTime).format('yyyy-mm-dd HH:MM:ss');
	$("#call-history-from-date").datetimepicker("setDate", new Date(checkInTime));


	var checkOutTime = Number(localStorage.getItem('checkout_'+extension));

	if(!checkOutTime){
		checkOutTime = new Date().getTime();
	}
	var checkOutDate = new Date(checkOutTime).format('yyyy-mm-dd HH:MM:ss');
	$("#call-history-to-date").datetimepicker("setDate",  new Date(checkOutTime));


	$("#call-history-modal .modal-body .call-history-wrapper").html('');
	$("#call-history-modal").modal('show');

	loadHistory(extension, checkInDate, checkOutDate);
}

function onClickUpdateCallHistory(event){
	var fromDate = $("#call-history-from-date").datetimepicker("getDate");

	if(fromDate){
		fromDate = fromDate.format('yyyy-mm-dd HH:MM');
	}
	var toDate = $("#call-history-to-date").datetimepicker("getDate");
	if(toDate){
		toDate = toDate.format('yyyy-mm-dd HH:MM');
	}

	loadHistory($('#call-history-modal').attr('extension'), fromDate, toDate);
}

var win = null;
function onClickPrintCallHistory(){
	var extension = $('#call-history-modal').attr('extension');
	var user = wtapi.roster.getUserByExtension(extension);
	if(win){
		win.close();
	}
	win = window.open(null, 'Print', 'width='+(window.screen.width*70/100)+',height='+(window.screen.height*70/100)+',resizable=yes,scrollbars=yes');

	var html = $("<div />").append($.tmpl("printCalls", {
		'user': user,
		'period': {
			from: $('#call-history-modal #call-history-from-date').val(),
			to: $('#call-history-modal #call-history-to-date').val()
		},
		'callsHistory': $('.call-history-wrapper').html(),
		'date': (new Date()).format('dd/mm/yyyy HH:MM')
	})).html();

	win.document.write(html);

	win.print();
}

function onClickAlarmClocks(event){
	var extension = $(event.target).closest('tr.user-item').attr('extension');
	if(extension){
		$('#alarm-clocks-modal .modal-body .alarm-clocks-wrapper').html($.tmpl("alarmClocksTemplate", {'alarmClocks': alarmClocks[extension], 'extension': extension}));
		$('#alarm-clocks-modal .modal-body .alarm-clocks-wrapper [data-toggle="tooltip"]').tooltip();
	}
	$("#alarm-clocks-modal").modal('show');
}

function onClickAddAlarmClock(event){
	var extension = $('#alarm-clocks-modal .modal-body .alarm-clocks-wrapper table').closest('table').attr('rel');

	var tomorrow = new Date();
	tomorrow.setDate(tomorrow.getDate() + 1);

	var postpone = (tomorrow.getDate() < 10)? '0' + tomorrow.getDate(): tomorrow.getDate();
	postpone += '/' + (((tomorrow.getMonth()+1) < 10)? '0' + (tomorrow.getMonth()+1): (tomorrow.getMonth()+1));
	postpone += '/' + tomorrow.getFullYear();
	postpone += ' 07:00';


	var table = $('#alarm-clock-edit-modal .modal-body .alarm-clock-edit-wrapper table');

	table.find('input[name="id"]').attr('readonly', 'readonly').val('');
	table.find('input[name="dialplan"]').val(options.dialplan);
	table.find('input[name="number"]').val(extension).attr('readonly', 'readonly');
	table.find('input[name="postpone"]').val(postpone);

	$('#alarm-clock-edit-modal').modal('show');
}
function onClickEditAlarmClock(event){
	var id = $(event.target).closest('tr.alarm-clock-item').attr('rel');
	var extension = $(event.target).closest('table').attr('rel');

	var alarmClock = null;
	for(var i=0; i < alarmClocks[extension].length; i++){
		if(alarmClocks[extension][i].id == id){
			alarmClock = alarmClocks[extension][i];
			break;
		}
	}

	if(alarmClock){
		var table = $('#alarm-clock-edit-modal .modal-body .alarm-clock-edit-wrapper table');

		table.find('input[name="id"]').attr('readonly', 'readonly').val(alarmClock.id);
		table.find('input[name="dialplan"]').val(alarmClock.dialplan);
		table.find('input[name="number"]').val(alarmClock.number).attr('readonly', 'readonly');
		table.find('input[name="postpone"]').val(alarmClock.postpone);

		$('#alarm-clock-edit-modal').modal('show');
	}
}

function onClickDelAlarmClock(event){
	var id = $(event.target).closest('tr.alarm-clock-item').attr('rel');
	var extension = $(event.target).closest('table').attr('rel');

	$.ajax({
		url: options.pbxUrl+'/api/v1/originate/AlarmClocks/'+id+'/',
		type: 'POST',
		data:{
			_METHOD: 'DELETE'
		},
		success:function(response, textStatus, jqXHR){
			if(response && response['type'] && response['type']=='result'){
				$(event.target).closest('tr.alarm-clock-item').remove();
				if(alarmClocks[extension]){
					alarmClocks[extension] = alarmClocks[extension].filter(function(item) {
						return item.id !== id;
					});
				}
				updateButtons();
			}else{
				console.log(response);
			}
		},
		error: function(jqXHR, textStatus, errorThrown){
			if(jqXHR.responseText && jqXHR.responseText!=''){
				var response = $.parseJSON(jqXHR.responseText);
				if(response && response['type'] && response['type'] == 'error' && response['reason']){
					showError('Error remove alarm clock', response['reason']);
				}
			}else{
				showError('Error remove alarm clock', errorThrown);
			}
		}
	});
}

function onClickSaveAlarmClock(event){

	var table = $('#alarm-clock-edit-modal .modal-body .alarm-clock-edit-wrapper table');

	var data = {};

	var id = $.trim(table.find('input[name="id"]').val());
	if(id && id!=''){
		data._METHOD = 'PUT'
	}

	var number = $.trim(table.find('input[name="number"]').val());
	if(number && number!=''){
		data.number = number;
	}

	var dialplan = $.trim(table.find('input[name="dialplan"]').val());
	if(dialplan && dialplan!=''){
		data.dialplan = dialplan;
	}else{
		data.dialplan = options.dialplan
	}

	var postpone = $.trim(table.find('input[name="postpone"]').val());
	if(postpone && postpone!=''){
		data.postpone = postpone;
	}


	$.ajax({
		url: options.pbxUrl+'/api/v1/originate/AlarmClocks/'+id,
		type: 'POST',
		data: data,
		success:function(response, textStatus, jqXHR){
			if(response && response['type'] && response['type']=='result'){
				$('#alarm-clock-edit-modal').modal('hide');
				if(!id || id == ''){
					// add new alarm clock
					if(!alarmClocks[data.number]){
						alarmClocks[data.number] = []
					}
					alarmClocks[data.number].push({
						id: response['result'],
						dialplan: options.dialplan,
						number: data.number,
						owner: options.login,
						postpone: data.postpone
					});
					updateButtons();
				}else{
					// update alarm clock
					if(alarmClocks[data.number]){
						for(var i=0; i < alarmClocks[data.number].length;i++){
							if(alarmClocks[data.number][i].id == id){
								alarmClocks[data.number][i].dialplan = data.dialplan;
								alarmClocks[data.number][i].postpone = data.postpone;
								break;
							}
						}
					}
				}

				$('#alarm-clocks-modal .modal-body .alarm-clocks-wrapper').html($.tmpl("alarmClocksTemplate", {'alarmClocks': alarmClocks[data.number], 'extension': data.number}));
				$('#alarm-clocks-modal .modal-body .alarm-clocks-wrapper [data-toggle="tooltip"]').tooltip();
			}else{
				console.log(response)
			}
		},
		error: function(jqXHR, textStatus, errorThrown){
			if(jqXHR.responseText && jqXHR.responseText!=''){
				var response = $.parseJSON(jqXHR.responseText);
				if(response && response['type'] && response['type'] == 'error' && response['reason']){
					showError('Error add alarm clock', response['reason']);
				}
			}else{
				showError('Error add alarm clock', errorThrown);
			}
		}
	});
}


function onPresenceChanged(user, presence) {
    var el = $('tr#user_'+user.getExtension()+' .name');
    var anchorEl = el.find("a:first");
    var showText = "";
    var showEl = el.find("i.user-status");
    var statusEl = el.find("span i");
    var statusText = "";
    var ringingEl = el.find("i.ringing");
    var talkingEl = el.find("i.talking");
    var untilText = "";
    var locationText = "";

    // Set user presence status

    if (presence.isOnline()) {
        if (presence.isAway()) {
        	showEl.html("<i class='fa-stack fa-lg away'><i class='fa fa-circle fa-stack-2x fa-inverse'></i><i class='fa fa-clock-o fa-stack-2x'></i></i>");
            showText += "Away";
        } else if (presence.isDND()) {
        	showEl.html("<i class='fa-stack fa-lg dnd'><i class='fa fa-circle fa-stack-2x fa-inverse'></i><i class='fa fa-minus-circle fa-stack-2x'></i></i>");
            showText += "DND";
        } else if(presence.isMUR()){
        	showEl.html("<i class='fa fa-cleaning mur'></i>");
            showText += "Make up room";
        }else {
        	showEl.html("<i class='fa fa-circle online'></i>");
            showText += "Online";
        }
    } else {
        if (presence.isAway()) {
        	showEl.html("<i class='fa-stack fa-lg away-offline'><i class='fa fa-circle fa-stack-2x fa-inverse'></i><i class='fa fa-clock-o fa-stack-2x'></i></i>");
            showText += "Away - offline";
        } else if (presence.isDND()) {
        	showEl.html("<i class='fa-stack fa-lg dnd-offline'><i class='fa fa-circle fa-stack-2x fa-inverse'></i><i class='fa fa-minus-circle fa-stack-2x'></i></i>");
            showText += "DND - offline";
        } else if(presence.isMUR()){
        	showEl.html("<i class='fa fa-cleaning mur-offline'></i>");
            showText += "Make up room - offline";
        }else {
        	showEl.html("<i class='fa fa-circle offline'></i>");
            showText += "Offline";
        }
    }

    // Set status message
    if (presence.isStatusMessageAvailable()) {
        statusText += presence.getStatusMessage();
        statusEl.html(presence.getStatusMessage());
    } else {
        statusText += "-"
        statusEl.html("");
    }

    // Set user device status (ringing / talking)
    ringingEl.css("display", "none");
    talkingEl.css("display", "none");
    if (presence.isTalkingAndRinging()) {
        showText += " (ringing + talking)"
    }else if (presence.isRinging()) {
    	showText += " (ringing)"
        ringingEl.css("display", "inline-block");
    }else if (presence.isTalking()) {
    	showText += " (talking)"
        talkingEl.css("display", "inline-block");
    }

    // Set location
    if (presence.isLocationAvailable()) {
        var addr = presence.getLocation().getAddress();
        var lat = presence.getLocation().getLat();
        var lng = presence.getLocation().getLng();

        if (addr.length > 26) {
            addr = addr.substring(0, 26) + "...";
        }

        locationText += addr
    } else {
        locationText = "-";
    }

    // Set until
    if (presence.isStatusUntilAvailable()) {
        untilText += formatDate(presence.getStatusUntil());
    } else {
        untilText += "-"
    }

    if (anchorEl.hasClass("tooltip-applied")) {
        anchorEl.tooltip("destroy");
    } else {
        anchorEl.addClass("tooltip-applied");
    }

    // Set tooltip
    var description = "<div style='text-align:left;'>Status: "+ showText +"</div>" +
        "<div style='text-align:left;'>Message: "+ statusText +"</div>" +
        "<div style='text-align:left;'>Until: "+ untilText +"</div>" +
        "<div style='text-align:left;'>Location: "+ locationText +"</div>";
    anchorEl.tooltip({title: description, placement: "left", html: true});

    var extension = user.getExtension();
	if(presence.isMUR()){
		$('#user_'+extension+' .actions .cleaning').hide();
		$('#user_'+extension+' .actions .cleaned').show();
	}else{
		$('#user_'+extension+' .actions .cleaning').show();
		$('#user_'+extension+' .actions .cleaned').hide();
	}
}

function onConnected(){
	let credentials = wtapi.getCredentials();

	$.ajaxSetup({
		crossDomain: true,
		xhrFields: {
			withCredentials: false
		},
		headers: {
			'Authorization': 'Bearer ' + credentials.accessToken
		}
	});

	getBlockingCalls();
	getAlarmClocks();

	if(updateTimer != null){
		clearTimeout(updateTimer);
		updateTimer = null;
	}
	updateTimer = setTimeout(function(){
		getBlockingCalls();
		getAlarmClocks();
	}, 10*60*1000);

	wtapi.roster.getRoster(onReceivedRoster);
}

function onDisconnected(){
	wtapi.deleteSavedCredentials();

	if(updateTimer != null){
		clearTimeout(updateTimer);
		updateTimer = null;
	}
}

function onReceivedRoster(roster){
	var groupedRoster = {};
	roster.sort(function(a,b){
		var compare = a.getGroup().localeCompare(b.getGroup());
		if(compare == 0){
			return parseInt(a.getExtension()) - parseInt(b.getExtension());
		}
		return compare;
	});
	for(var i=0; i< roster.length; i++){
		if(!groupedRoster[roster[i].getGroup()]){
			groupedRoster[roster[i].getGroup()] = [];
		}
		groupedRoster[roster[i].getGroup()].push(roster[i]);
	}

	$('#hotel-view .users-list').html($.tmpl("usersTemplate", {'roster': groupedRoster}));

	var emptyPresence = new WTAPI.Presence();
	for(var i=0; i< roster.length; i++){
		onPresenceChanged(roster[i], emptyPresence);
	}

	$('#hotel-view .users-list [data-toggle="tooltip"]').tooltip();
	updateButtons();
}



